=== debian/changelog ===
kid3 (1.6-2) unstable; urgency=low

  * Bump debhelper to version 7.
  * Bump Standards-Version to 3.9.2 (no changes needed).
  * Wrap build dependencies.
  * Build with enabled hardening-wrapper.

 -- Patrick Matthäi <pmatthaei@debian.org>  Sat, 30 Apr 2011 20:10:56 +0200

kid3 (1.6-1) unstable; urgency=low

  * New upstream release.
  * Remove odd build dependency libqt3-i18n.
  * Uploading to unstable.

 -- Patrick Matthäi <pmatthaei@debian.org>  Sat, 05 Feb 2011 14:14:11 +0100

kid3 (1.5-1) experimental; urgency=low

  * New upstream release.
  * Bump Standards-Version to 3.9.1 (no changes needed).

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 08 Nov 2010 20:51:56 +0100
